• hdu 1688 Sightseeing (最短路径)


    Sightseeing

    Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
    Total Submission(s): 639    Accepted Submission(s): 249


    Problem Description
    Tour operator Your Personal Holiday organises guided bus trips across the Benelux. Every day the bus moves from one city S to another city F. On this way, the tourists in the bus can see the sights alongside the route travelled. Moreover, the bus makes a number of stops (zero or more) at some beautiful cities, where the tourists get out to see the local sights.

    Different groups of tourists may have different preferences for the sights they want to see, and thus for the route to be taken from S to F. Therefore, Your Personal Holiday wants to offer its clients a choice from many different routes. As hotels have been booked in advance, the starting city S and the final city F, though, are fixed. Two routes from S to F are considered different if there is at least one road from a city A to a city B which is part of one route, but not of the other route.

    There is a restriction on the routes that the tourists may choose from. To leave enough time for the sightseeing at the stops (and to avoid using too much fuel), the bus has to take a short route from S to F. It has to be either a route with minimal distance, or a route which is one distance unit longer than the minimal distance. Indeed, by allowing routes that are one distance unit longer, the tourists may have more choice than by restricting them to exactly the minimal routes. This enhances the impression of a personal holiday.



    For example, for the above road map, there are two minimal routes from S = 1 to F = 5: 1 → 2 → 5 and 1 → 3 → 5, both of length 6. There is one route that is one distance unit longer: 1 → 3 → 4 → 5, of length 7.

    Now, given a (partial) road map of the Benelux and two cities S and F, tour operator Your Personal Holiday likes to know how many different routes it can offer to its clients, under the above restriction on the route length.

     
    Input
    The first line of the input file contains a single number: the number of test cases to follow. Each test case has the following format:

    One line with two integers N and M, separated by a single space, with 2 ≤ N ≤ 1,000 and 1 ≤ M ≤ 10, 000: the number of cities and the number of roads in the road map.

    M lines, each with three integers A, B and L, separated by single spaces, with 1 ≤ A, B ≤ N, A ≠ B and 1 ≤ L ≤ 1,000, describing a road from city A to city B with length L.

    The roads are unidirectional. Hence, if there is a road from A to B, then there is not necessarily also a road from B to A. There may be different roads from a city A to a city B.

    One line with two integers S and F, separated by a single space, with 1 ≤ S, F ≤ N and S ≠ F: the starting city and the final city of the route.

    There will be at least one route from S to F.

     
    Output
    For every test case in the input file, the output should contain a single number, on a single line: the number of routes of minimal length or one distance unit longer. Test cases are such, that this number is at most 10^9 = 1,000,000,000.

     
    Sample Input
    2
    5 8
    1 2 3
    1 3 2
    1 4 5
    2 3 1
    2 5 3
    3 4 2
    3 5 4
    4 5 3
    1 5
    5 6
    2 3 1
    3 2 1
    3 1 10
    4 5 2
    5 2 7
    5 2 7
    4 1
     
    Sample Output
    3
    2
     
    Source
     
    Recommend
    lcy   |   We have carefully selected several similar problems for you:  2833 2433 2363 2482 2377 
     

     题意就是 求最短路径数和比最短路径大1的路径数的和。

    和3191几乎一样+ +自己写了一下次短路,结果wa了好多次...不过这种解法效率真的很高!

     1 //15MS    528K    2372 B    C++    
     2 #include<iostream>
     3 #include<queue>
     4 #include<vector>
     5 #define inf 0x3fffffff
     6 #define N 1005
     7 using namespace std;
     8 struct edge{
     9     int v,w;
    10     edge(int a,int b){
    11         v=a;w=b;
    12     }
    13 };
    14 struct node{
    15     int v,w;
    16     int mark;
    17     bool operator < (const node &p) const{
    18         return p.w<w;
    19         //return p.v<v;
    20     }
    21 };
    22 vector<edge>V[N];
    23 int n,m,s,e;
    24 int d[N][3];
    25 int dp[N][3]; 
    26 int vis[N][3];
    27 void dijkstra(int s)
    28 {
    29     for(int i=0;i<=n;i++)
    30         d[i][1]=d[i][2]=inf;
    31     memset(dp,0,sizeof(dp));
    32     memset(vis,0,sizeof(vis));
    33     priority_queue<node>Q;
    34     node p,q;
    35     d[s][1]=0;
    36     dp[s][1]=1;
    37     p.w=0,p.mark=1,p.v=s;
    38     Q.push(p);
    39     while(!Q.empty()){
    40         p=Q.top();
    41         Q.pop();
    42         if(vis[p.v][p.mark]) continue;
    43         vis[p.v][p.mark]=1;
    44         int m=V[p.v].size();
    45         for(int i=0;i<m;i++){
    46             int v=V[p.v][i].v;
    47             int w=V[p.v][i].w;
    48             if(!vis[v][1] && d[v][1]>p.w+w){
    49                 if(d[v][1]!=inf){
    50                     d[v][2]=d[v][1];
    51                     dp[v][2]=dp[v][1];
    52                     q.v=v,q.mark=2,q.w=d[v][2];
    53                     Q.push(q);
    54                 }
    55                 d[v][1]=p.w+w;
    56                 dp[v][1]=dp[p.v][p.mark];
    57                 q.v=v,q.mark=1,q.w=d[v][1];
    58                 Q.push(q);
    59             }else if(!vis[v][1] && d[v][1]==p.w+w){
    60                 dp[v][1]+=dp[p.v][p.mark];
    61             }else if(!vis[v][2] && d[v][2]>p.w+w){
    62                 d[v][2]=p.w+w;
    63                 dp[v][2]=dp[p.v][p.mark];
    64                 q.v=v,q.mark=2,q.w=d[v][2];
    65                 Q.push(q);
    66             }else if(!vis[v][2] && d[v][2]==p.w+w){
    67                 dp[v][2]+=dp[p.v][p.mark];
    68             }
    69         }
    70     }              
    71 }
    72 int main(void)
    73 {   
    74     int u,v,w;
    75     int t;
    76     scanf("%d",&t);
    77     while(t--)
    78     {
    79         scanf("%d%d",&n,&m);
    80         for(int i=0;i<=n;i++)
    81             V[i].clear();
    82         for(int i=0;i<m;i++){
    83             scanf("%d%d%d",&u,&v,&w);
    84             V[u].push_back(edge(v,w));
    85             //V[v].push_back(edge(u,w));
    86         }
    87         scanf("%d%d",&s,&e);
    88         dijkstra(s);
    89         int ans=dp[e][1];
    90         //printf("*%d %d %d
    ",ans,d[e][1],d[e][2]);
    91         if(d[e][2]==d[e][1]+1) ans+=dp[e][2];
    92         printf("%d
    ",ans);
    93     }
    94     return 0;
    95 }
  • 相关阅读:
    hibernate对应的annocation版本
    Struts 2 OGNL
    Struts2的Stack Context和ValueStack
    Struts2中的OGNL详解
    struts2中根对象以及ognl .
    在Struts 2中实现IoC
    Struts2的属性驱动与模型驱动的区别
    Struts2的模型驱动
    Java中线程的锁和数据库中的事务隔离级别
    为什么socket编程要用到多线程
  • 原文地址:https://www.cnblogs.com/GO-NO-1/p/3739645.html
Copyright © 2020-2023  润新知